
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'dbo.[GetOwnDepLink]') AND xtype in (N'FN', N'IF', N'TF'))
DROP FUNCTION dbo.[GetOwnDepLink]

GO

/*
c  (Keysystems), 2005
*/
CREATE   FUNCTION [GetOwnDepLink]()
RETURNS int
AS
BEGIN
RETURN (SELECT TOP 1 LINK FROM dbo.DEPARTMENTS WHERE TYPE = 4)
END



GO


GRANT EXECUTE ON dbo.[GetOwnDepLink] TO PUBLIC

GO




if exists (select * from dbo.sysobjects where id = object_id(N'[REPORT_CONTROL_ROWS_CACHE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [REPORT_CONTROL_ROWS_CACHE]
GO

CREATE TABLE [REPORT_CONTROL_ROWS_CACHE] (
	[Link] [int] IDENTITY (1, 1) NOT NULL ,
	[Link_Rule] [int] NOT NULL CONSTRAINT [DF_REPORT_CONTROL_ROWS_CACHE_Link_Rule] DEFAULT (0),
	[OrderRow] [int] NOT NULL CONSTRAINT [DF_REPORT_CONTROL_ROWS_CACHE_OrderRow] DEFAULT (0),
	[Val_Type] [tinyint] NOT NULL CONSTRAINT [DF_REPORT_CONTROL_ROWS_CACHE_Val_Type] DEFAULT (0),
	[SignBefore] [char] (2)  NOT NULL CONSTRAINT [DF_REPORT_CONTROL_ROWS_CACHE_SignBefore] DEFAULT (''),
	[SignAfter] [char] (2)  NOT NULL CONSTRAINT [DF_REPORT_CONTROL_ROWS_CACHE_SignAfter] DEFAULT (''),
	[Link_Table] [int] NULL CONSTRAINT [DF_REPORT_CONTROL_ROWS_CACHE_LinkTable] DEFAULT (0),
	[Link_Col] [int] NULL CONSTRAINT [DF_REPORT_CONTROL_ROWS_CACHE_LinkCol] DEFAULT (0),
	[Link_Row] [int] NULL CONSTRAINT [DF_REPORT_CONTROL_ROWS_CACHE_LinkRow] DEFAULT (0),
	[Code_Row] [varchar] (50)  NULL CONSTRAINT [DF_REPORT_CONTROL_ROWS_CACHE_CodeRow] DEFAULT (''),
	[Factor] [float] NOT NULL CONSTRAINT [DF_REPORT_CONTROL_ROWS_CACHE_Factor] DEFAULT (0),
	[Exec_Proc] [varchar] (250)  NOT NULL CONSTRAINT [DF_REPORT_CONTROL_ROWS_CACHE_Exec_Proc] DEFAULT (''),
	[orders] [varchar] (50)  NOT NULL CONSTRAINT [DF_REPORT_CONTROL_ROWS_CACHE_orders] DEFAULT (''),
	[upd_date] [datetime] NOT NULL CONSTRAINT [DF_REPORT_CONTROL_ROWS_CACHE_upd_date] DEFAULT (getdate()),
	[Link_form] [int] NOT NULL ,
	[isLeftPart] [bit] NOT NULL CONSTRAINT [DF_REPORT_CONTROL_ROWS_CACHE_isLeftPart] DEFAULT (0),
	[Filter] [varchar] (250)  NOT NULL CONSTRAINT [DF_REPORT_CONTROL_ROWS_CACHE_Filter] DEFAULT (''),
	[Maska] [varchar] (250)  NOT NULL CONSTRAINT [DF_REPORT_CONTROL_ROWS_CACHE_Maska] DEFAULT (''),
	[Period_Form] [smallint] NULL ,
	[Exec_Proc_Desc] [varchar] (250)  NOT NULL CONSTRAINT [DF_REPORT_CONTROL_ROWS_CACHE_Exec_Proc_Desc] DEFAULT (''),
	[Filter_Desc] [varchar] (250)  NOT NULL CONSTRAINT [DF_REPORT_CONTROL_ROWS_CACHE_Filter_Desc] DEFAULT (''),
	[Maska_Desc] [varchar] (250)  NOT NULL CONSTRAINT [DF_REPORT_CONTROL_ROWS_CACHE_Maska_Desc] DEFAULT (''),
	[Calc_Orders] [int] NOT NULL CONSTRAINT [DF_REPORT_CONTROL_ROWS_CACHE_Calc_Orders] DEFAULT (0),
	[isDoschet] [bit] NOT NULL CONSTRAINT [DF_REPORT_CONTROL_ROWS_CACHE_isDoschet] DEFAULT (0),
	CONSTRAINT [FK_REPORT_CONTROL_ROWS_CACHE_REPORT_CONTROL_RULES] FOREIGN KEY 
	(
		[Link_Rule]
	) REFERENCES [REPORT_CONTROL_RULES] (
		[Link_Rule]
	) ON DELETE CASCADE 
) ON [PRIMARY]
GO


IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'dbo.[RN_WEB_EDIT_TABLES]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE dbo.[RN_WEB_EDIT_TABLES]

GO
/*

    (Keysystems), 2006
  / //   WEB   
*/


CREATE       PROCEDURE dbo.RN_WEB_EDIT_TABLES
  @varKSnLink bigint,
  @varKSnTree int = 0, --   ,    ,  -   
        @varKSisHeader int = 0
AS

declare @iLF int
DECLARE @DATE datetime,
  @PType  tinyint,
  @PNom tinyint,
  @DATE1 datetime,
  @DATE2 datetime, 
  @Periodic tinyint,
  @LSF  int,
  @Mode int,
  @LinkOrg int,
  @LinkBudg int,
  @atributs varchar(250)


set @LinkOrg = dbo.RO_SVOD_ORG(@varKSnTree)
set @LinkBudg = dbo.RO_SVOD_BUDG(@varKSnTree)
set @Mode = convert(int, @varKSnLink/4294967296)
set @varKSnLink = @varKSnLink - @Mode * 4294967296
set @Mode = abs(@Mode)
set @atributs = ''

print @varKSnTree
IF @varKSnTree=-2
 begin
       EXECUTE RO_WEB_EDIT_OBJECT_METHOD_SVOD @varKSnLink
       RETURN 
 end
IF @varKSnLink<0 and @varKSnTree>0 -- 
 begin
       EXECUTE RO_WEB_EDIT_OBJECT_METHOD_SVOD @varKSnLink=@varKSnLink,@varKSnTree=@varKSnLink,@varKSisHeader=@varKSnLink
       RETURN 
 end

/*    */
if @varKSnLink > 0
begin
--     
select @atributs=isnull(RTRIM(atributs),'') from REPORT_FORMS where Link_Form = (select link_form from Report_Saved_Forms where link_saved_form = @varKSnLink)

  SELECT  [alias] = 'REP_HEAD', 
    [order] = convert(smallint,0),
    [tab_name] = '',
    [link_table] = convert(varchar(50), 'REPORT_SVOD'),--convert(int,0),
    [table_type] = convert(smallint,2) 
  UNION
SELECT	[alias] = 'REP_ATR', 
	[order] = convert(smallint, 1),
	[tab_name] = '',
	[link_table] = convert(varchar(50), '-98'),
	[table_type] = convert(smallint, 0)
    WHERE @atributs<>'' 
UNION
  SELECT  [alias] = 'REP_TABLE_1', 
    [order] = (orders - 1) * 3 + 1,
    [tab_name] = name,
    [link_table] = convert(varchar(50), Link_Table),
    [table_type] = val_type 
  FROM REPORT_TABLES
  WHERE link_table = @varKSnTree and @varKSnTree>0
  UNION
  SELECT  [alias] = 'REP_RGB_1', 
    [order] = (orders - 1) * 3 + 2,
    [tab_name] = name,
    [link_table] = convert(varchar(50), Link_Table),
    [table_type] = 21 
  FROM REPORT_TABLES
  WHERE link_table = @varKSnTree and @varKSnTree>0
  UNION
--  SELECT  [alias] = 'REP_RO_1', 
--    [order] = (orders - 1) * 3 + 3,
--    [tab_name] = name,
--    [link_table] = convert(varchar(50), Link_Table),
--    [table_type] = 22
--  FROM REPORT_TABLES
--  WHERE link_table = @varKSnTree and @varKSnTree>0
--  UNION
  SELECT  [alias] = 'REP_NASTR', 
    [order] = convert(smallint, 99),
    [tab_name] = ' ',
    [link_table] = convert(varchar(50), '0'),
    [table_type] = convert(smallint, -1)
  ORDER BY [order]
end
else begin --  
  SELECT  [alias] = 'REP_HEAD', 
    [order] = convert(smallint,1),
    [tab_name] = '',
    [link_table] = convert(varchar(50), 'REPORT_SVOD'),
    [table_type] = convert(smallint,2)
  UNION
  SELECT  [alias] = 'REP_NASTR', 
    [order] = convert(smallint, 99),
    [tab_name] = ' ',
    [link_table] = convert(varchar(50), '0'),
    [table_type] = convert(smallint, -1)
  ORDER by [order]
end
/*    */
if @varKSnLink > 0 and (@varKSnTree>0 )
begin
  CREATE TABLE #REP_HEAD_temp ("checked" Int,"UPD" Int,"del" Int,"date" DateTime,"date_prov" DateTime,"link" Int,"period" VarChar(17),"name" VarChar(200),"code" Char(20),"Start_Date" Char(10),"link_saved_form" Int,"Link_form" Int,"Version" SmallInt,"begin_date" DateTime,"period_type" TinyInt,"period_type_web" Int,"period_number" TinyInt,"period_year" Int,"link_organization" Int,"dep_name" VarChar(254),"dep_code" Char(10),"isUpload" TinyInt,"isSvod" TinyInt,"isChangeAnalit" Bit,"IsRO" TinyInt,"Note" VarChar(500),"Link_Type_Svod" Int,"Type_Svod" VarChar(250),"IsUsedRazdel" Int,"IsUsedCelSt" Int,"IsUsedRashod" Int,"LinkRazdel" Int,"LinkCelSt" Int,"LinkRashod" Int,"CodeRazdel" VarChar(1),"NameRazdel" VarChar(1),"CodeCelSt" VarChar(1),"NameCelSt" VarChar(1),"CodeRashod" VarChar(1),"NameRashod" VarChar(1),"Print_Object_Method" VarChar(200),"Query_Add_Module" VarChar(200),"Query_Before" VarChar(200),"Query_RepMaker" VarChar(200),"Query_Report" VarChar(200),"Query_Report_Path" VarChar(200),"Decript_Proc" VarChar(30),"IsRemoteAccess" TinyInt,"RULES" TinyInt,"isCalcItog" Int,"IsRO_MASK" Int,"CountSave" Int,"Object" Char(30),[IS_AUTOFILL] TINYINT,"IsCopy" BIT,"End_Date" Char(10))
  insert #REP_HEAD_temp exec I_REPORT_USER_SAVED_FORM @varKSiLinkSF =@varKSnLink, @bIsWeb = 1 -- 
        -- countsave  report_saved_tables
        IF @varKSnTree>0
                UPDATE #REP_HEAD_temp SET CountSave=coalesce((select top 1 countsave from REPORT_SAVED_TABLES where Link_Saved_Form=@varKSnLink and Link_Table=@varKSnTree),0)

  select @varKSnTree as Link_Table, * from #REP_HEAD_temp
  drop table #REP_HEAD_temp

    --
    IF @atributs<>''
    begin
        exec RN_GET_ATRIBUT_VALUES  @varKSnLink,null,0
    end

  /*  ,  ,  readonly */
  DECLARE @iLTable  INT,
    @cRuStr   varchar(8000)
-- 
  SET @cRuStr = 'EXEC dbo.RI_PROC_T' + ltrim(convert(varchar(15),@varKSnTree)) + ' ' + (case when @varKSnLink>0 then convert(varchar(15), @varKSnLink) else '0'  end)+',default,default,default,default,default,default,default,1'
  SET @cRuStr = @cRuStr + ' EXEC dbo.RO_TOTAL_CELLS ' + LTRIM(STR(@varKSnTree)) + ', ' + (case when @varKSnLink>0 then convert(varchar(15), @varKSnLink) else '0'  end)+ ',''COL'',2'
-- 
--  SET @cRuStr = 'EXEC dbo.RI_PROC_T' + ltrim(convert(varchar(15),@varKSnTree)) + ' ' + (case when @varKSnLink>0 then convert(varchar(15), @varKSnLink) else '0'  end)
--  SET @cRuStr = @cRuStr + ' EXEC dbo.RO_TOTAL_CELLS ' + LTRIM(STR(@varKSnTree)) + ', ' + (case when @varKSnLink>0 then convert(varchar(15), @varKSnLink) else '0'  end)
--  SET @cRuStr = @cRuStr + ' EXEC dbo.RO_TOTAL_CELLS ' + LTRIM(STR(@varKSnTree)) + ', ' + (case when @varKSnLink>0 then convert(varchar(15), @varKSnLink) else '0'  end) + ', ''COL'', 1'

  print @cRuStr
  execute (@cRuStr)
-- 
print @varKSnLink
print @varKSnTree
  IF @varKSnLink>0 
	exec RN_LOCK_FORM @varKSnLink,@varKSnTree,'',1
end
else
begin --  
   
        IF  @varKSnTree=-1
        BEGIN
          --PRINT 'exec I_REPORT_USER_SAVED_FORM @varKSnLink, @LinkOrg, @LinkBudg, 1'
          exec I_REPORT_USER_SAVED_FORM @varKSnLink, @LinkOrg, @LinkBudg, 1
        END
        ELSE BEGIN                  
          IF @varKSnTree=-1000
          BEGIN
            --PRINT 'I_REPORT_USER_SAVED_FORM @varKSnLink, @LinkOrg, @LinkBudg, 1,1'          
            EXEC I_REPORT_USER_SAVED_FORM @varKSnLink, @LinkOrg, @LinkBudg, 1,1
          END
          ELSE BEGIN
            --PRINT 'I_REPORT_USER_SAVED_FORM @varKSnLink, @LinkOrg, @LinkBudg'          
            EXEC I_REPORT_USER_SAVED_FORM @varKSnLink, @LinkOrg, @LinkBudg
          END
        END





    --
    IF @atributs<>''
    begin
        exec RN_GET_ATRIBUT_VALUES  @varKSnLink,null,0
    end

end

/*   */
DECLARE @iLOrg  int,
  @DocDate  datetime
EXEC @iLOrg = getowndeplink 
IF @varKSnLink>0
  select @iLOrg = link_organization, @DocDate = begin_date from report_saved_forms where link_saved_form = @varKSnLink
ELSE
  select @DocDate = getdate()

select *, convert(char(10), @DocDate + 1, 104) as Doc_Date from dbo.PrintDoc_GetDepData2 (@iLOrg)



GO


GRANT EXECUTE ON dbo.[RN_WEB_EDIT_TABLES] TO PUBLIC

GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'dbo.[RN_PRINT_SVOD]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE dbo.[RN_PRINT_SVOD]

GO
/*

	  (Keysystems), 2006
	/ //   WEB
*/


CREATE       PROCEDURE dbo.RN_PRINT_SVOD
	@varKSnLink	bigint,
	@varKSnTree	int = 0,
    @bDeleteEmptyRows BIT = NULL,  --  NULL -     , 1 -    ( DEL = 1), 0 -  .
    @data int=1

AS

declare @iLF int
DECLARE @DATE	datetime,
	@PType	tinyint,
	@PNom	tinyint,
	@DATE1 datetime,
	@DATE2 datetime, 
	@Periodic tinyint,
	@LSF	int,
	@Mode	int,
	@LinkOrg int,
	@LinkBudg int,
    @atributs varchar(250)
set @LinkOrg = dbo.RO_SVOD_ORG(@varKSnTree)
set @LinkBudg = dbo.RO_SVOD_BUDG(@varKSnTree)
set @Mode = convert(int, @varKSnLink/4294967296)
set @varKSnLink = @varKSnLink - @Mode * 4294967296
set @Mode = abs(@Mode)

--     
select @atributs=isnull(RTRIM(atributs),'') from REPORT_FORMS where Link_Form = (select link_form from Report_Saved_Forms where link_saved_form = @varKSnLink)

if @varKSnLink<0
    select @atributs=isnull(RTRIM(atributs),'') from REPORT_FORMS where Link_Form = -@varKSnLink



/*    */

create table #org (code varchar(20), name varchar(250))


/*IF @varKSnLink > 0
BEGIN
	EXEC dbo.[I_REPORT_USER_SAVED_FORM] @varKSiLinkSF = @varKSnLink,
                                       @bIsWeb = 1
END
ELSE BEGIN 
	EXEC dbo.[I_REPORT_USER_SAVED_FORM] @varKSnLink, @LinkOrg, @LinkBudg,
                                       @bIsWeb = 1
END
*/
--exec I_REPORT_USER_SAVED_FORM @varKSnLink

/*  ,  ,  readonly */
DECLARE @iLTable	INT,
	@cRuStr		varchar(8000)
DECLARE tables_cursor CURSOR FOR 
	SELECT link_table FROM report_tables 
		WHERE (@varKSnLink>0 and Link_Form = (select link_form from Report_Saved_Forms where link_saved_form = @varKSnLink))
			OR (@varKSnLink<0 and Link_Form = abs(@varKSnLink))


declare @nameProcTable varchar(50)
set @nameProcTable='dbo.RI_PROC_T'
--IF @bDeleteEmptyRows is not null and (select code from report_forms where Link_Form = (select top 1 link_form from Report_Saved_Forms where link_saved_form = @varKSnLink))='428'
--begin
--    CREATE TABLE #REPORT_DINAMICS(link_SF int,Link_Col int,Code_Row varchar(50),Float_val numeric(20,4),Str_Val varchar(250))
    --   #REPORT_DINAMICS     428 
--    exec RN_CALCULATE_PODITOG @varKSnLink
--    set @nameProcTable='dbo.RI_PROC_T#'    
--end

--
/*
IF @atributs<>''
    begin
        IF @varKSnLink<0
            begin
                set @iLF=-@varKSnLink
                exec RN_GET_ATRIBUT_VALUES  null,@iLF,0
            end
        else
            exec RN_GET_ATRIBUT_VALUES  @varKSnLink,null,0
    end
*/

if @data=1	
	select '' col1 


OPEN tables_cursor
FETCH NEXT FROM tables_cursor INTO @iLTable
WHILE @@FETCH_STATUS = 0
BEGIN
    SET @cRuStr = 'EXEC '+@nameProcTable + ltrim(convert(varchar(15),@iLTable)) + ' @varKSLSF = ' + (case when @varKSnLink>0 then convert(varchar(15), @varKSnLink) else '0'  end) + ', @bDeleteEmptyRows = ' + ISNULL(CAST(@bDeleteEmptyRows AS VARCHAR),'NULL')+',@del_fcol =1' 
--	SET @cRuStr = @cRuStr + ' EXEC dbo.RO_TOTAL_CELLS ' + LTRIM(STR(@iLTable)) + ', ' + (case when @varKSnLink>0 then convert(varchar(15), @varKSnLink) else '0'  end) + ', ''COL'', 2,default,default,default,'+str(ISNULL(CAST(@bDeleteEmptyRows AS VARCHAR),0))

--    SET @cRuStr = 'EXEC '+@nameProcTable + ltrim(convert(varchar(15),@iLTable)) + ' @varKSLSF = ' + (case when @varKSnLink>0 then convert(varchar(15), @varKSnLink) else '0'  end) + ', @bDeleteEmptyRows = ' + ISNULL(CAST(@bDeleteEmptyRows AS VARCHAR),'NULL')
--	SET @cRuStr = @cRuStr + ' EXEC dbo.RO_TOTAL_CELLS ' + LTRIM(STR(@iLTable)) + ', ' + (case when @varKSnLink>0 then convert(varchar(15), @varKSnLink) else '0'  end)
--	SET @cRuStr = @cRuStr + ' EXEC dbo.RO_TOTAL_CELLS ' + LTRIM(STR(@iLTable)) + ', ' + (case when @varKSnLink>0 then convert(varchar(15), @varKSnLink) else '0'  end) + ', ''COL'', 1'
--print    @cRuStr
	if @data=1	
		execute (@cRuStr)

	FETCH NEXT FROM tables_cursor INTO @iLTable
END

CLOSE tables_cursor
DEALLOCATE tables_cursor

/*   */
DECLARE	@iLOrg	int,
	@DocDate	datetime
EXEC @iLOrg = getowndeplink 
IF @varKSnLink>0
	select @iLOrg = link_organization, @DocDate = begin_date from report_saved_forms where link_saved_form = @varKSnLink
ELSE
	select @DocDate = getdate()

declare @code_atr varchar(50),@str_val varchar(250)
create table #print_tmp (code_atr varchar(50),atr_name varchar(254),str_val varchar(1000))
    insert #print_tmp 
        exec RN_GET_ATRIBUT_VALUES  @varKSnLink,null,1
    set @cRuStr=''
    while exists(select * from #print_tmp)
        begin
            select top 1 @code_atr=code_atr,@str_val='#'+str_val from #print_tmp 
            set @cRuStr=@cRuStr+case when @cRuStr='' then ',' else ',' end + ''''+@str_val+''' as '+@code_atr        
            delete #print_tmp where code_atr=@code_atr
        end


create table #c_nastr (nastr varchar(20),value varchar(4000),ftype varchar(20))

insert #c_nastr (nastr,value,ftype)
SELECT 'GLBUH',GLBUH.SHORT_NAME,'C'
	FROM dbo.GetOtvFaceData(@iLOrg, ' ') GLBUH 
	WHERE GLBUH.link_dep = @iLOrg

insert #c_nastr (nastr,value,ftype)
SELECT 'CHIEF',CHIEF.SHORT_NAME,'C'
	FROM dbo.GetOtvFaceData(@iLOrg, '') chief 
	WHERE chief.link_dep = @iLOrg

insert #c_nastr (nastr,value,ftype)
SELECT 'CHIEF_POST',CHIEF.POST_NAME,'C'
	FROM dbo.GetOtvFaceData(@iLOrg, '') chief 
	WHERE chief.link_dep = @iLOrg

insert #c_nastr (nastr,value,ftype)
SELECT 'FULL_NAME',CONVERT(VARCHAR(254),DD1.FULL_NAME) AS FULL_NAME,'C'
	FROM DICTIONARY_DEPARTMENT DD1 
	WHERE DD1.LINK = @iLOrg

insert #c_nastr (nastr,value,ftype)
SELECT 'DEP_FULL_NAME',CONVERT(VARCHAR(254),DD1.FULL_NAME) AS FULL_NAME,'C'
	FROM DICTIONARY_DEPARTMENT DD1 
	WHERE DD1.LINK = @iLOrg

insert #c_nastr (nastr,value,ftype)
SELECT 'NAME',CONVERT(VARCHAR(254),DD1.NAME) AS NAME,'C'
	FROM DICTIONARY_DEPARTMENT DD1 
	WHERE DD1.LINK = @iLOrg

insert #c_nastr (nastr,value,ftype)
SELECT 'OKPO',DD1.OKPO,'C'
	FROM DICTIONARY_DEPARTMENT DD1 
	WHERE DD1.LINK = @iLOrg

insert #c_nastr (nastr,value,ftype)
SELECT 'OKATO',DD1.OKATO,'C'
	FROM DICTIONARY_DEPARTMENT DD1 
	WHERE DD1.LINK = @iLOrg

insert #c_nastr (nastr,value,ftype)
SELECT 'SONO',DD1.NALOG,'C'
	FROM DICTIONARY_DEPARTMENT DD1 
	WHERE DD1.LINK = @iLOrg

insert #c_nastr (nastr,value,ftype)
SELECT 'REGION',isnull((SELECT RTRIM(LTRIM(NAME)) + ' ' + LTRIM(RTRIM(SOCR)) FROM DICTIONARY_KLADR WHERE CODE = LEFT(DD1.NALOG, 2) + REPLICATE('0', 11)),''),'C'
	FROM DICTIONARY_DEPARTMENT DD1 
	WHERE DD1.LINK = @iLOrg

insert #c_nastr (nastr,value,ftype)
SELECT 'OKVED',DD1.OKVED,'C'
	FROM DICTIONARY_DEPARTMENT DD1 
	WHERE DD1.LINK = @iLOrg

insert #c_nastr (nastr,value,ftype)
SELECT 'OKVED1',REPLACE (DD1.OKVED, '.', ''),'C'
	FROM DICTIONARY_DEPARTMENT DD1 
	WHERE DD1.LINK = @iLOrg

-----------------------------------
insert #c_nastr (nastr,value,ftype)
SELECT 'DOC_DATE','01.11.2008','C'

insert #c_nastr (nastr,value,ftype)
SELECT 'REPORTS_ATR_ADM','000','C'

REPORTS_ATR_ADM

if @data=0
	select * from #c_nastr		

GO


GRANT EXECUTE ON dbo.[RN_PRINT_SVOD] TO PUBLIC

GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'dbo.[RO_WEB_EDIT_OBJECT_METHOD_SVOD]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE dbo.[RO_WEB_EDIT_OBJECT_METHOD_SVOD]

GO

/*

	  (Keysystems), 2006
	/ //   WEB
*/


CREATE       PROCEDURE dbo.RO_WEB_EDIT_OBJECT_METHOD_SVOD
	@varKSnLink	bigint,
	@varKSnTree	int = 0,
    @bDeleteEmptyRows BIT = NULL,  --  NULL -     , 1 -    ( DEL = 1), 0 -  .
    @varKSisHeader int = 0, -- 1   
    @repository int = 0 -- 1   
AS

declare @iLF int
DECLARE @DATE	datetime,
	@PType	tinyint,
	@PNom	tinyint,
	@DATE1 datetime,
	@DATE2 datetime, 
	@Periodic tinyint,
	@LSF	int,
	@Mode	int,
	@LinkOrg int,
	@LinkBudg int,
    @atributs varchar(250)
set @LinkOrg = dbo.RO_SVOD_ORG(@varKSnTree)
set @LinkBudg = dbo.RO_SVOD_BUDG(@varKSnTree)
set @Mode = convert(int, @varKSnLink/4294967296)
set @varKSnLink = @varKSnLink - @Mode * 4294967296
set @Mode = abs(@Mode)

--     
select @atributs=isnull(RTRIM(atributs),'') from REPORT_FORMS where Link_Form = (select link_form from Report_Saved_Forms where link_saved_form = @varKSnLink)

if @varKSnLink<0
    select @atributs=isnull(RTRIM(atributs),'') from REPORT_FORMS where Link_Form = -@varKSnLink

/*    */
SELECT	[alias] = 'REP_HEAD', 
	[order] = convert(smallint,0),
	[tab_name] = '',
	[link_table] = convert(int,0),
	[table_type] = convert(smallint,2)
UNION
SELECT	[alias] = 'REP_ATR', 
	[order] = convert(smallint, 1),
	[tab_name] = '',
	[link_table] = convert(int, -98),
	[table_type] = convert(smallint, 0)
    WHERE @atributs<>'' 
UNION
SELECT	[alias] = 'REP_TABLE_' + ltrim(convert(char(2),orders)), 
	[order] = (orders - 1) * 3 + 1,
	[tab_name] = name,
	[link_table] = Link_Table,
	[table_type] = val_type
FROM REPORT_TABLES
WHERE (@varKSisHeader=0 and @varKSnLink>0 and Link_Form = (select link_form from Report_Saved_Forms where link_saved_form = @varKSnLink))
	OR (@varKSisHeader=0 and @varKSnLink<0 and Link_Form = abs(@varKSnLink))
UNION
SELECT	[alias] = 'REP_RGB_' + ltrim(convert(char(2),orders)), 
	[order] = (orders - 1) * 3 + 2,
	[tab_name] = name,
	[link_table] = Link_Table,
	[table_type] = 21
FROM REPORT_TABLES
WHERE (@varKSisHeader=0 and @varKSnLink>0 and Link_Form = (select link_form from Report_Saved_Forms where link_saved_form = @varKSnLink))
	OR (@varKSisHeader=0 and @varKSnLink<0 and Link_Form = abs(@varKSnLink))
UNION
--SELECT	[alias] = 'REP_RO_' + ltrim(convert(char(2),orders)), 
--	[order] = (orders - 1) * 3 + 3,
--	[tab_name] = name,
--	[link_table] = Link_Table,
--	[table_type] = 22
--FROM REPORT_TABLES
--WHERE (@varKSisHeader=0 and @varKSnLink>0 and Link_Form = (select link_form from Report_Saved_Forms where link_saved_form = @varKSnLink))
--	OR (@varKSisHeader=0 and @varKSnLink<0 and Link_Form = abs(@varKSnLink))
--UNION
SELECT	[alias] = 'REP_NASTR', 
	[order] = convert(smallint, 99),
	[tab_name] = ' ',
	[link_table] = convert(int, 0),
	[table_type] = convert(smallint, -1)
ORDER BY [order]



/*    */

create table #org (code varchar(20), name varchar(250))



IF @varKSnLink > 0
BEGIN
	EXEC dbo.[I_REPORT_USER_SAVED_FORM] @varKSiLinkSF = @varKSnLink,
                                       @bIsWeb = 1
END
ELSE BEGIN 
	EXEC dbo.[I_REPORT_USER_SAVED_FORM] @varKSnLink, @LinkOrg, @LinkBudg,
                                       @bIsWeb = 1
END

--exec I_REPORT_USER_SAVED_FORM @varKSnLink

/*  ,  ,  readonly */
DECLARE @iLTable	INT,
	@cRuStr		varchar(8000)
DECLARE tables_cursor CURSOR FOR 
	SELECT link_table FROM report_tables 
		WHERE (@varKSisHeader=0 and @varKSnLink>0 and Link_Form = (select link_form from Report_Saved_Forms where link_saved_form = @varKSnLink))
			OR (@varKSisHeader=0 and @varKSnLink<0 and Link_Form = abs(@varKSnLink))


declare @nameProcTable varchar(50)
set @nameProcTable='dbo.RI_PROC_T'
--IF @bDeleteEmptyRows is not null and (select code from report_forms where Link_Form = (select top 1 link_form from Report_Saved_Forms where link_saved_form = @varKSnLink))='428'
--begin
--    CREATE TABLE #REPORT_DINAMICS(link_SF int,Link_Col int,Code_Row varchar(50),Float_val numeric(20,4),Str_Val varchar(250))
    --   #REPORT_DINAMICS     428 
--    exec RN_CALCULATE_PODITOG @varKSnLink
--    set @nameProcTable='dbo.RI_PROC_T#'    
--end

--
IF @atributs<>''
    begin
        IF @varKSnLink<0
            begin
                set @iLF=-@varKSnLink
                exec RN_GET_ATRIBUT_VALUES  null,@iLF,0
            end
        else
            exec RN_GET_ATRIBUT_VALUES  @varKSnLink,null,0
    end

declare @iCode_Col int,@atr varchar(100),@tmp_table_main varchar(100),@tmp_table varchar(100),@cnt int,@LF int,@code_form varchar(50),@begin_date datetime,@period_type int,@period_number int,@link_org int,@link_type_svod int
create table #LSF (lsf int, link_Form int, codeForm char(20), startDate datetime)

select @code_form=code,@LF=link_form from report_forms where link_form=(select top 1 link_form from report_saved_forms where link_saved_form=@varKSnLink)


declare @cstr varchar(100)
exec X_GET_OPTION 'OBJ_FTP_REGION',0,@cStr output

select @LSF=link_saved_form,@begin_date=begin_date,@period_type=period_type,@period_number=period_number,@link_org=link_organization,@link_type_svod=link_type_svod from report_saved_forms where link_saved_form=@varKSnLink
IF @bDeleteEmptyRows is not null and @code_form in ('(72)0503127M','0503127M') and @cStr=''
	begin
		insert #LSF exec dbo.I_REPORT_ORG_FORMS_LIST @link_Org, @Begin_date, @period_Type, @period_number, 0, @link_type_svod 
		delete #LSF where link_form<>@LF
	end
--
IF @bDeleteEmptyRows is  null
	exec rn_lock_form @varKSnLink,0,'',1

EXEC dbo.X_GET_TABLE_NAME @tmp_table_main OUTPUT
EXEC dbo.X_GET_TABLE_NAME @tmp_table OUTPUT

select @cnt=count(*) from #LSF

OPEN tables_cursor
FETCH NEXT FROM tables_cursor INTO @iLTable
WHILE @@FETCH_STATUS = 0
BEGIN
	IF @cnt>1
		begin
			select @LSF=link_saved_form,@begin_date=begin_date,@period_type=period_type,@period_number=period_number,@link_org=link_organization,@link_type_svod=link_type_svod from report_saved_forms where link_saved_form=@varKSnLink
			delete #LSF
			insert #LSF exec dbo.I_REPORT_ORG_FORMS_LIST @link_Org, @Begin_date, @period_Type, @period_number, 0, @link_type_svod 
			delete #LSF where link_form<>@LF
			select @iCode_Col=orders from report_coloumns where link_col=(select top 1 link_code_col from report_tables where link_table=@iLTable)
			select top 1 @LSF=lsf from #LSF 
			delete #LSF where lsf=@lsf
			set @atr=rtrim(dbo.RN_GET_ATR_VALUE(@lsf,'REPORTS_ATR_ADM'))
			SET @cRuStr = 'EXEC '+@nameProcTable + ltrim(convert(varchar(15),@iLTable)) + ' @varKSLSF = ' + convert(varchar(15), @LSF)+ ', @bDeleteEmptyRows = ' + ISNULL(CAST(@bDeleteEmptyRows AS VARCHAR),'NULL')+',@del_fcol =1,@tmp_table='+@tmp_table_main
			execute (@cRuStr)		


			SET @cRuStr='UPDATE '+@tmp_table_main+' set COL'+ltrim(str(@iCode_Col))+'=rtrim('''+@atr+''')+RTRIM(COL'+ltrim(str(@iCode_Col))+'),CODE=rtrim('''+@atr+''')+RTRIM(CODE)'
			print @cRuStr
			execute (@cRuStr)
			while exists(select * from #LSF) 
				begin
					select top 1 @LSF=lsf from #LSF 
					delete #LSF where lsf=@lsf
					SET @cRuStr = 'EXEC '+@nameProcTable + ltrim(convert(varchar(15),@iLTable)) + ' @varKSLSF = ' + convert(varchar(15), @LSF)+ ', @bDeleteEmptyRows = ' + ISNULL(CAST(@bDeleteEmptyRows AS VARCHAR),'NULL')+',@del_fcol =1,@tmp_table='+@tmp_table
--					print @cRuStr
					execute (@cRuStr)					
					set @atr=dbo.RN_GET_ATR_VALUE(@lsf,'REPORTS_ATR_ADM')
					SET @cRuStr='UPDATE '+@tmp_table+' set COL'+ltrim(str(@iCode_Col))+'=rtrim('''+@atr+''')+COL'+ltrim(str(@iCode_Col))+',CODE=rtrim('''+@atr+''')+CODE'
--					print @cRuStr
					execute (@cRuStr)					



					SET @cRuStr='insert '+@tmp_table_main+' select * from '+@tmp_table+' drop table ' +@tmp_table
--					print @cRuStr
					execute (@cRuStr)					
				end

			SET @cRuStr='select * from  '+@tmp_table_main+'  drop table ' +@tmp_table_main
--			print @cRuStr
			execute (@cRuStr)					
			SET @cRuStr = ' EXEC dbo.RO_TOTAL_CELLS ' + LTRIM(STR(@iLTable)) + ', ' + (case when @varKSnLink>0 then convert(varchar(15), @varKSnLink) else '0'  end) + ', ''COL'', 2,default,default,default,'+str(ISNULL(CAST(@bDeleteEmptyRows AS VARCHAR),0))
--			print @cRuStr
			execute (@cRuStr)					
		end
	else
	begin	
		SET @cRuStr = 'EXEC '+@nameProcTable + ltrim(convert(varchar(15),@iLTable)) + ' @varKSLSF = ' + (case when @varKSnLink>0 then convert(varchar(15), @varKSnLink) else '0'  end) + ', @bDeleteEmptyRows = ' + ISNULL(CAST(@bDeleteEmptyRows AS VARCHAR),'NULL')+',@del_fcol =1' 
		SET @cRuStr = @cRuStr + ' EXEC dbo.RO_TOTAL_CELLS ' + LTRIM(STR(@iLTable)) + ', ' + (case when @varKSnLink>0 then convert(varchar(15), @varKSnLink) else '0'  end) + ', ''COL'', 2,default,default,default,'+str(ISNULL(CAST(@bDeleteEmptyRows AS VARCHAR),0))
		execute (@cRuStr)
	end
--    SET @cRuStr = 'EXEC '+@nameProcTable + ltrim(convert(varchar(15),@iLTable)) + ' @varKSLSF = ' + (case when @varKSnLink>0 then convert(varchar(15), @varKSnLink) else '0'  end) + ', @bDeleteEmptyRows = ' + ISNULL(CAST(@bDeleteEmptyRows AS VARCHAR),'NULL')
--	SET @cRuStr = @cRuStr + ' EXEC dbo.RO_TOTAL_CELLS ' + LTRIM(STR(@iLTable)) + ', ' + (case when @varKSnLink>0 then convert(varchar(15), @varKSnLink) else '0'  end)
--	SET @cRuStr = @cRuStr + ' EXEC dbo.RO_TOTAL_CELLS ' + LTRIM(STR(@iLTable)) + ', ' + (case when @varKSnLink>0 then convert(varchar(15), @varKSnLink) else '0'  end) + ', ''COL'', 1'
--print    @cRuStr

	FETCH NEXT FROM tables_cursor INTO @iLTable
END

CLOSE tables_cursor
DEALLOCATE tables_cursor

/*   */
DECLARE	@iLOrg	int,
	@DocDate	datetime
EXEC @iLOrg = getowndeplink 
IF @varKSnLink>0
	select @iLOrg = link_organization, @DocDate = begin_date from report_saved_forms where link_saved_form = @varKSnLink
ELSE
	select @DocDate = getdate()

declare @code_atr varchar(50),@str_val varchar(250)
create table #print_tmp (code_atr varchar(50),atr_name varchar(254),str_val varchar(1000))
    insert #print_tmp 
        exec RN_GET_ATRIBUT_VALUES  @varKSnLink,null,1
    set @cRuStr=''
    while exists(select * from #print_tmp)
        begin
            select top 1 @code_atr=code_atr,@str_val='#'+str_val from #print_tmp 
            set @cRuStr=@cRuStr+case when @cRuStr='' then ',' else ',' end + ''''+@str_val+''' as '+@code_atr        
            delete #print_tmp where code_atr=@code_atr
        end



set @cRuStr='
       SELECT [A].*, 
	   [BUDG_NAME]			 = '''+coalesce((select [name] from dbo.kl_budg_type where link = @LinkBudg),'')+''',
	   [OKATO1]				 = ISNULL([A].[OKATO],''''),
       [DOC_DATE]            = '''+CONVERT(CHAR(10), @DocDate + 1, 104)+''',
       [PERFORMER_FIO]       = ISNULL([B].[FIO],''''),
       [PERFORMER_POST]      = ISNULL([B].[POST],''''),
       [PERFORMER_PHONE]     = ISNULL([B].[PHONES],''''),
       [CHIEF_SOC_POST]      = ISNULL([C].[CHIEF_SOC_POST],''''),
       [CHIEF_SOC_FIO]       = ISNULL([C].[CHIEF_SOC_FIO],''''),
       [PERFORMER_SOC_POST]  = ISNULL([C].[PERFORMER_SOC_POST],''''),
       [PERFORMER_SOC_FIO]   = ISNULL([C].[PERFORMER_SOC_FIO],''''),
       [PERFORMER_SOC_PHONE] = ISNULL([C].[PERFORMER_SOC_PHONE],'''')'+@cRuStr+
' FROM dbo.[PrintDoc_GetDepData2] ('+str(@iLOrg)+') [A]
LEFT JOIN dbo.[I_REPORT_OPTIONS_COMMON]  [C] ON 1=1
LEFT JOIN dbo.[RA_GET_USER_INFO](NULL)   [B] ON 1=1'
--print 	@cRuStr
execute (@cRuStr)   

GO


GRANT EXECUTE ON dbo.[RO_WEB_EDIT_OBJECT_METHOD_SVOD] TO PUBLIC

GO


